# Build project from bundled dependencies
%global with_bundled 0
# Build with debug info rpm
%global with_debug 0
# Run tests in check section
%global with_check 1
# Generate unit-test rpm
%global with_unit_test 1

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        gopkg
%global provider_tld    in
%global project         DATA-DOG
%global apiver          1
%global repo            go-sqlmock
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}.v%{apiver}
%global import_path     %{provider_prefix}
%global commit          d76b18b42f285b792bf985118980ce9eacea9d10
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

%global common_description %{expand:
A mock library implementing SQL driver, which has one and only purpose - to
simulate any SQL driver behavior in tests, without needing a real database
connection. It helps to maintain correct TDD workflow.

It does not require any modifications to your source code in order to test and
mock database operations. Supports concurrency and multiple database mocking.
}

Name:           golang-%{provider}-data-dog-sqlmock-%{apiver}
Version:        1.3.0
Release:        2%{?dist}
Summary:        SQL mock driver for golang to test database interactions
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://github.com/%{project}/%{repo}/archive/v%{version}/%{repo}-%{version}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{common_description}


%package devel
Summary:       %{summary}
BuildArch:     noarch

Provides:      golang(%{provider_prefix}) = %{version}-%{release}


%description devel
%{common_description}

This package contains library source intended for building other packages which
use import path with %{provider_prefix} prefix.

%prep
%setup -q -n %{repo}-%{version}


%install
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." > devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . \( -iname "*.go" -or -iname "*.s" \) \! -iname "*_test.go") ; do
    file="${file##./}"
    dirprefix="$(dirname "${file}")"
    install -d -p "%{buildroot}/%{gopath}/src/%{import_path}/${dirprefix}" >&2
    cp -pav "${file}" "%{buildroot}/%{gopath}/src/%{import_path}/${file}" >&2
    echo "%%{gopath}/src/%%{import_path}/${file}"

    while [ "$dirprefix" != "." ]; do
        echo "%%dir %%{gopath}/src/%%{import_path}/$dirprefix"
        dirprefix=$(dirname $dirprefix)
    done
done | sort -u >>devel.file-list


%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
# No dependency directories so far

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}
%endif

%files devel -f devel.file-list
%license LICENSE
%doc README.md


%changelog
* Wed Aug 15 2018 Michal Minář <miminar@redhat.com> - 1.3.0-2
- Fixed provides.

* Thu Jul 26 2018 Michal Minář <miminar@redhat.com> - 1.3.0-1
- Initial epel7 release.
